"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const getCleanStringKeys = (enumeration) => {
    const objKeys = Object.keys(enumeration);
    return objKeys
        .filter((value) => isNaN(+value))
        .map((value) => enumeration[value]);
};
exports.getEnumValues = (enumeration) => {
    const enumerationObj = JSON.parse(JSON.stringify(enumeration));
    return getCleanStringKeys(enumerationObj);
};
exports.getMaxLengthOfEnumValues = (enumeration) => {
    const enumerationValuesLengths = exports.getEnumValues(enumeration)
        .map((enumerationValue) => enumerationValue.length);
    if (enumerationValuesLengths.indexOf(undefined) !== -1) {
        throw new Error(`Enumeration can contain only string values to get a max length.`);
    }
    return Math.max(...enumerationValuesLengths);
};
