import { PoolOptions, SyncOptions } from 'sequelize';
import { Model, Sequelize } from 'sequelize-typescript';
import { DatabaseCredentials } from './database.module';
export interface ProviderOptions {
    logging?: Function;
    operatorsAliases?: boolean;
    pool?: PoolOptions;
    syncOptions?: SyncOptions;
}
export declare class DatabaseProvider {
    private readonly sequelize;
    static create(models: (typeof Model)[] | undefined, credentials: DatabaseCredentials, options?: ProviderOptions): Promise<DatabaseProvider>;
    private static instance;
    constructor(sequelize: Sequelize);
    getConnection(): Sequelize;
}
