"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var DatabaseProvider_1;
Object.defineProperty(exports, "__esModule", { value: true });
"use strict";
const common_1 = require("@nestjs/common");
const sequelize_typescript_1 = require("sequelize-typescript");
let DatabaseProvider = DatabaseProvider_1 = class DatabaseProvider {
    constructor(sequelize) {
        this.sequelize = sequelize;
    }
    static create(models = [], credentials, options) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!credentials) {
                throw new Error('Database provider needs the credentials to be instantiated.');
            }
            if (!DatabaseProvider_1.instance) {
                const sequelize = new sequelize_typescript_1.Sequelize({
                    database: credentials.name,
                    dialect: credentials.dialect,
                    password: credentials.password,
                    host: credentials.host,
                    port: credentials.port,
                    username: credentials.user,
                    operatorsAliases: options && options.operatorsAliases ? options.operatorsAliases : false,
                    logging: options && options.logging && {}.toString.call(options.logging) === '[object Function]' ?
                        options.logging :
                        undefined,
                    pool: options && options.pool ?
                        options.pool :
                        undefined,
                });
                sequelize.addModels(models);
                if (options && options.syncOptions) {
                    yield sequelize.sync(options.syncOptions);
                }
                DatabaseProvider_1.instance = sequelize;
            }
            return new DatabaseProvider_1(DatabaseProvider_1.instance);
        });
    }
    getConnection() {
        return this.sequelize;
    }
};
DatabaseProvider = DatabaseProvider_1 = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [sequelize_typescript_1.Sequelize])
], DatabaseProvider);
exports.DatabaseProvider = DatabaseProvider;
